Added health check after installation before exit
[osm/devops.git] / installers / full_install_osm.sh
1 #!/bin/bash
2 # Copyright 2016 Telefónica Investigación y Desarrollo S.A.U.
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 function usage(){
17 echo -e "usage: $0 [OPTIONS]"
18 echo -e "Install OSM from binaries or source code (by default, from binaries)"
19 echo -e " OPTIONS"
20 echo -e " -r <repo>: use specified repository name for osm packages"
21 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
22 echo -e " -u <repo base>: use specified repository url for osm packages"
23 echo -e " -k <repo key>: use specified repository public key url"
24 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
25 echo -e " -b master (main dev branch)"
26 echo -e " -b v2.0 (v2.0 branch)"
27 echo -e " -b tags/v1.1.0 (a specific tag)"
28 echo -e " ..."
29 echo -e " -c <orchestrator> deploy osm services using container <orchestrator>. Valid values are <k8s> or <swarm>. If -c is not used then osm will be deployed using default orchestrator. When used with --uninstall, osm services deployed by the orchestrator will be uninstalled"
30 echo -e " -n <ui> install OSM with Next Gen UI. Valid values are <lwui> or <ngui>. If -n is not specified osm will be installed with light-ui. When used with uninstall, osm along with the UI specified will be uninstalled"
31 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
32 echo -e " -H <VCA host> use specific juju host controller IP"
33 echo -e " -S <VCA secret> use VCA/juju secret key"
34 echo -e " -P <VCA pubkey> use VCA/juju public key file"
35 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
36 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
37 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
38 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
39 echo -e " --pla: install the PLA module for placement support"
40 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, PLA, NONE)"
41 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, k8s_monitor)"
42 echo -e " -O <openrc file/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
43 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
44 echo -e " -D <devops path> use local devops installation path"
45 echo -e " -w <work dir> Location to store runtime installation"
46 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
47 echo -e " -l: LXD cloud yaml file"
48 echo -e " -L: LXD credentials yaml file"
49 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
50 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
51 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
52 echo -e " --nojuju: do not juju, assumes already installed"
53 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
54 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
55 echo -e " --nohostclient: do not install the osmclient"
56 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
57 echo -e " --source: install OSM from source code using the latest stable tag"
58 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
59 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
60 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
61 echo -e " --volume: create a VM volume when installing to OpenStack"
62 # echo -e " --reconfigure: reconfigure the modules (DO NOT change NAT rules)"
63 # echo -e " --update: update to the latest stable release or to the latest commit if using a specific branch"
64 echo -e " --showopts: print chosen options and exit (only for debugging)"
65 echo -e " -y: do not prompt for confirmation, assumes yes"
66 echo -e " -h / --help: print this help"
67 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
68 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
69 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
70 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
71 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
72 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
73 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
74 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
75 echo -e " [--tag]: Docker image tag"
76
77 }
78
79 # takes a juju/accounts.yaml file and returns the password specific
80 # for a controller. I wrote this using only bash tools to minimize
81 # additions of other packages
82 function parse_juju_password {
83 password_file="${HOME}/.local/share/juju/accounts.yaml"
84 local controller_name=$1
85 local s='[[:space:]]*' w='[a-zA-Z0-9_-]*' fs=$(echo @|tr @ '\034')
86 sed -ne "s|^\($s\):|\1|" \
87 -e "s|^\($s\)\($w\)$s:$s[\"']\(.*\)[\"']$s\$|\1$fs\2$fs\3|p" \
88 -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p" $password_file |
89 awk -F$fs -v controller=$controller_name '{
90 indent = length($1)/2;
91 vname[indent] = $2;
92 for (i in vname) {if (i > indent) {delete vname[i]}}
93 if (length($3) > 0) {
94 vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
95 if (match(vn,controller) && match($2,"password")) {
96 printf("%s",$3);
97 }
98 }
99 }'
100 }
101
102 function generate_secret() {
103 head /dev/urandom | tr -dc A-Za-z0-9 | head -c 32
104 }
105
106 function remove_volumes() {
107 if [ -n "$KUBERNETES" ]; then
108 k8_volume=$1
109 echo "Removing ${k8_volume}"
110 $WORKDIR_SUDO rm -rf ${k8_volume}
111 else
112 stack=$1
113 volumes="mongo_db mon_db osm_packages ro_db pol_db prom_db ro"
114 for volume in $volumes; do
115 sg docker -c "docker volume rm ${stack}_${volume}"
116 done
117 fi
118 }
119
120 function remove_network() {
121 stack=$1
122 sg docker -c "docker network rm net${stack}"
123 }
124
125 function remove_iptables() {
126 stack=$1
127 if [ -z "$OSM_VCA_HOST" ]; then
128 OSM_VCA_HOST=`sg lxd -c "juju show-controller ${stack}"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
129 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
130 fi
131
132 if [ -z "$DEFAULT_IP" ]; then
133 DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
134 [ -z "$DEFAULT_IF" ] && DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
135 [ -z "$DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
136 DEFAULT_IP=`ip -o -4 a |grep ${DEFAULT_IF}|awk '{split($4,a,"/"); print a[1]}'`
137 [ -z "$DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
138 fi
139
140 if sudo iptables -t nat -C PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST; then
141 sudo iptables -t nat -D PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST
142 sudo netfilter-persistent save
143 fi
144 }
145
146 function remove_stack() {
147 stack=$1
148 if sg docker -c "docker stack ps ${stack}" ; then
149 echo -e "\nRemoving stack ${stack}" && sg docker -c "docker stack rm ${stack}"
150 COUNTER=0
151 result=1
152 while [ ${COUNTER} -lt 30 ]; do
153 result=$(sg docker -c "docker stack ps ${stack}" | wc -l)
154 #echo "Dockers running: $result"
155 if [ "${result}" == "0" ]; then
156 break
157 fi
158 let COUNTER=COUNTER+1
159 sleep 1
160 done
161 if [ "${result}" == "0" ]; then
162 echo "All dockers of the stack ${stack} were removed"
163 else
164 FATAL "Some dockers of the stack ${stack} could not be removed. Could not clean it."
165 fi
166 sleep 5
167 fi
168 }
169
170 #removes osm deployments and services
171 function remove_k8s_namespace() {
172 kubectl delete ns $1
173 }
174
175 #removes helm only if there is nothing deployed in helm
176 function remove_helm() {
177 if [ "$(helm ls -q)" == "" ] ; then
178 sudo helm reset --force
179 kubectl delete --namespace kube-system serviceaccount tiller
180 kubectl delete clusterrolebinding tiller-cluster-rule
181 sudo rm /usr/local/bin/helm
182 rm -rf $HOME/.helm
183 fi
184 }
185
186 #Uninstall osmclient
187 function uninstall_osmclient() {
188 sudo apt-get remove --purge -y python-osmclient
189 sudo apt-get remove --purge -y python3-osmclient
190 }
191
192 #Uninstall lightweight OSM: remove dockers
193 function uninstall_lightweight() {
194 if [ -n "$INSTALL_ONLY" ]; then
195 if [ -n "$INSTALL_ELK" ]; then
196 echo -e "\nUninstalling OSM ELK stack"
197 remove_stack osm_elk
198 $WORKDIR_SUDO rm -rf $OSM_DOCKER_WORK_DIR/osm_elk
199 fi
200 else
201 echo -e "\nUninstalling OSM"
202 if [ -n "$KUBERNETES" ]; then
203 if [ -n "$INSTALL_K8S_MONITOR" ]; then
204 # uninstall OSM MONITORING
205 uninstall_k8s_monitoring
206 fi
207 remove_k8s_namespace $OSM_STACK_NAME
208 else
209
210 remove_stack $OSM_STACK_NAME
211 remove_stack osm_elk
212 fi
213 echo "Now osm docker images and volumes will be deleted"
214 newgrp docker << EONG
215 docker image rm ${DOCKER_USER}/ro:${OSM_DOCKER_TAG}
216 docker image rm ${DOCKER_USER}/lcm:${OSM_DOCKER_TAG}
217 docker image rm ${DOCKER_USER}/light-ui:${OSM_DOCKER_TAG}
218 docker image rm ${DOCKER_USER}/keystone:${OSM_DOCKER_TAG}
219 docker image rm ${DOCKER_USER}/nbi:${OSM_DOCKER_TAG}
220 docker image rm ${DOCKER_USER}/mon:${OSM_DOCKER_TAG}
221 docker image rm ${DOCKER_USER}/pol:${OSM_DOCKER_TAG}
222 docker image rm ${DOCKER_USER}/pla:${OSM_DOCKER_TAG}
223 docker image rm ${DOCKER_USER}/osmclient:${OSM_DOCKER_TAG}
224 EONG
225
226 if [ -n "$NGUI" ]; then
227 newgrp docker << EONG
228 docker image rm ${DOCKER_USER}/ng-ui:${OSM_DOCKER_TAG}
229 EONG
230 else
231 newgrp docker << EONG
232 docker image rm ${DOCKER_USER}/light-ui:${OSM_DOCKER_TAG}
233 EONG
234 fi
235
236 if [ -n "$KUBERNETES" ]; then
237 OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
238 remove_volumes $OSM_NAMESPACE_VOL
239 else
240 remove_volumes $OSM_STACK_NAME
241 remove_network $OSM_STACK_NAME
242 fi
243 [ -z "$CONTROLLER_NAME" ] && remove_iptables $OSM_STACK_NAME
244 echo "Removing $OSM_DOCKER_WORK_DIR"
245 $WORKDIR_SUDO rm -rf $OSM_DOCKER_WORK_DIR
246 [ -z "$CONTROLLER_NAME" ] && sg lxd -c "juju destroy-controller --destroy-all-models --yes $OSM_STACK_NAME"
247 fi
248 uninstall_osmclient
249 echo "Some docker images will be kept in case they are used by other docker stacks"
250 echo "To remove them, just run 'docker image prune' in a terminal"
251 return 0
252 }
253
254 #Safe unattended install of iptables-persistent
255 function check_install_iptables_persistent(){
256 echo -e "\nChecking required packages: iptables-persistent"
257 if dpkg -l iptables-persistent &>/dev/null; then
258 echo -e " Not installed.\nInstalling iptables-persistent requires root privileges"
259 echo iptables-persistent iptables-persistent/autosave_v4 boolean true | sudo debconf-set-selections
260 echo iptables-persistent iptables-persistent/autosave_v6 boolean true | sudo debconf-set-selections
261 sudo apt-get -yq install iptables-persistent
262 fi
263 }
264
265 #Configure NAT rules, based on the current IP addresses of containers
266 function nat(){
267 check_install_iptables_persistent
268
269 echo -e "\nConfiguring NAT rules"
270 echo -e " Required root privileges"
271 sudo $OSM_DEVOPS/installers/nat_osm
272 }
273
274 function FATAL(){
275 echo "FATAL error: Cannot install OSM due to \"$1\""
276 exit 1
277 }
278
279 function install_lxd() {
280 # Apply sysctl production values for optimal performance
281 sudo cp /usr/share/osm-devops/installers/60-lxd-production.conf /etc/sysctl.d/60-lxd-production.conf
282 sudo sysctl --system
283
284 # Install LXD snap
285 sudo apt-get remove --purge -y liblxc1 lxc-common lxcfs lxd lxd-client
286 sudo snap install lxd
287 sudo apt-get install zfsutils-linux -y
288
289 # Configure LXD
290 sudo usermod -a -G lxd `whoami`
291 cat /usr/share/osm-devops/installers/lxd-preseed.conf | sed 's/^config: {}/config:\n core.https_address: '$DEFAULT_IP':8443/' | sg lxd -c "lxd init --preseed"
292 sg lxd -c "lxd waitready"
293 DEFAULT_INTERFACE=$(ip route list|awk '$1=="default" {print $5; exit}')
294 [ -z "$DEFAULT_INTERFACE" ] && DEFAULT_INTERFACE=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
295 DEFAULT_MTU=$(ip addr show $DEFAULT_INTERFACE | perl -ne 'if (/mtu\s(\d+)/) {print $1;}')
296 sg lxd -c "lxc profile device set default eth0 mtu $DEFAULT_MTU"
297 sg lxd -c "lxc network set lxdbr0 bridge.mtu $DEFAULT_MTU"
298 #sudo systemctl stop lxd-bridge
299 #sudo systemctl --system daemon-reload
300 #sudo systemctl enable lxd-bridge
301 #sudo systemctl start lxd-bridge
302 }
303
304 function ask_user(){
305 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
306 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
307 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
308 read -e -p "$1" USER_CONFIRMATION
309 while true ; do
310 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
311 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
312 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
313 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
314 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
315 done
316 }
317
318 function install_osmclient(){
319 CLIENT_RELEASE=${RELEASE#"-R "}
320 CLIENT_REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
321 CLIENT_REPOSITORY=${REPOSITORY#"-r "}
322 CLIENT_REPOSITORY_BASE=${REPOSITORY_BASE#"-u "}
323 key_location=$CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE/$CLIENT_REPOSITORY_KEY
324 curl $key_location | sudo apt-key add -
325 sudo add-apt-repository -y "deb [arch=amd64] $CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE $CLIENT_REPOSITORY osmclient IM"
326 sudo apt-get update
327 sudo apt-get install -y python3-pip
328 sudo -H LC_ALL=C python3 -m pip install -U pip
329 sudo -H LC_ALL=C python3 -m pip install -U python-magic pyangbind verboselogs
330 sudo apt-get install -y python3-osm-im python3-osmclient
331 #sed 's,OSM_SOL005=[^$]*,OSM_SOL005=True,' -i ${HOME}/.bashrc
332 #echo 'export OSM_HOSTNAME=localhost' >> ${HOME}/.bashrc
333 #echo 'export OSM_SOL005=True' >> ${HOME}/.bashrc
334 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_HOSTNAME=`lxc list | awk '($2=="SO-ub"){print $6}'`
335 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_RO_HOSTNAME=`lxc list | awk '($2=="RO"){print $6}'`
336 echo -e "\nOSM client installed"
337 if [ -z "$INSTALL_LIGHTWEIGHT" ]; then
338 echo -e "You might be interested in adding the following OSM client env variables to your .bashrc file:"
339 echo " export OSM_HOSTNAME=${OSM_HOSTNAME}"
340 echo " export OSM_RO_HOSTNAME=${OSM_RO_HOSTNAME}"
341 else
342 echo -e "OSM client assumes that OSM host is running in localhost (127.0.0.1)."
343 echo -e "In case you want to interact with a different OSM host, you will have to configure this env variable in your .bashrc file:"
344 echo " export OSM_HOSTNAME=<OSM_host>"
345 fi
346 return 0
347 }
348
349 function install_prometheus_nodeexporter(){
350 if (systemctl -q is-active node_exporter)
351 then
352 echo "Node Exporter is already running."
353 else
354 echo "Node Exporter is not active, installing..."
355 if getent passwd node_exporter > /dev/null 2>&1; then
356 echo "node_exporter user exists"
357 else
358 echo "Creating user node_exporter"
359 sudo useradd --no-create-home --shell /bin/false node_exporter
360 fi
361 wget -q https://github.com/prometheus/node_exporter/releases/download/v$PROMETHEUS_NODE_EXPORTER_TAG/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64.tar.gz -P /tmp/
362 sudo tar -C /tmp -xf /tmp/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64.tar.gz
363 sudo cp /tmp/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64/node_exporter /usr/local/bin
364 sudo chown node_exporter:node_exporter /usr/local/bin/node_exporter
365 sudo rm -rf /tmp/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64*
366 sudo cp ${OSM_DEVOPS}/installers/docker/prometheus_exporters/node_exporter.service /etc/systemd/system/node_exporter.service
367 sudo systemctl daemon-reload
368 sudo systemctl restart node_exporter
369 sudo systemctl enable node_exporter
370 echo "Node Exporter has been activated in this host."
371 fi
372 return 0
373 }
374
375 function uninstall_prometheus_nodeexporter(){
376 sudo systemctl stop node_exporter
377 sudo systemctl disable node_exporter
378 sudo rm /etc/systemd/system/node_exporter.service
379 sudo systemctl daemon-reload
380 sudo userdel node_exporter
381 sudo rm /usr/local/bin/node_exporter
382 return 0
383 }
384
385 function install_docker_ce() {
386 # installs and configures Docker CE
387 echo "Installing Docker CE ..."
388 sudo apt-get -qq update
389 sudo apt-get install -y apt-transport-https ca-certificates software-properties-common
390 curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
391 sudo add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu $(lsb_release -cs) stable"
392 sudo apt-get -qq update
393 sudo apt-get install -y docker-ce
394 echo "Adding user to group 'docker'"
395 sudo groupadd -f docker
396 sudo usermod -aG docker $USER
397 sleep 2
398 sudo service docker restart
399 echo "... restarted Docker service"
400 sg docker -c "docker version" || FATAL "Docker installation failed"
401 echo "... Docker CE installation done"
402 return 0
403 }
404
405 function install_docker_compose() {
406 # installs and configures docker-compose
407 echo "Installing Docker Compose ..."
408 sudo curl -L https://github.com/docker/compose/releases/download/1.18.0/docker-compose-`uname -s`-`uname -m` -o /usr/local/bin/docker-compose
409 sudo chmod +x /usr/local/bin/docker-compose
410 echo "... Docker Compose installation done"
411 }
412
413 function install_juju() {
414 echo "Installing juju"
415 sudo snap install juju --classic --channel=2.7/stable
416 [[ ":$PATH": != *":/snap/bin:"* ]] && PATH="/snap/bin:${PATH}"
417 echo "Finished installation of juju"
418 return 0
419 }
420
421 function juju_createcontroller() {
422 if ! juju show-controller $OSM_STACK_NAME &> /dev/null; then
423 # Not found created, create the controller
424 sudo usermod -a -G lxd ${USER}
425 sg lxd -c "juju bootstrap --bootstrap-series=xenial $OSM_VCA_CLOUDNAME $OSM_STACK_NAME"
426 fi
427 [ $(juju controllers | awk "/^${OSM_STACK_NAME}[\*| ]/{print $1}"|wc -l) -eq 1 ] || FATAL "Juju installation failed"
428 }
429
430 function juju_createproxy() {
431 check_install_iptables_persistent
432
433 if ! sudo iptables -t nat -C PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST; then
434 sudo iptables -t nat -A PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST
435 sudo netfilter-persistent save
436 fi
437 }
438
439 function generate_docker_images() {
440 echo "Pulling and generating docker images"
441 _build_from=$COMMIT_ID
442 [ -z "$_build_from" ] && _build_from="master"
443
444 echo "OSM Docker images generated from $_build_from"
445
446 BUILD_ARGS+=(--build-arg REPOSITORY="$REPOSITORY")
447 BUILD_ARGS+=(--build-arg RELEASE="$RELEASE")
448 BUILD_ARGS+=(--build-arg REPOSITORY_KEY="$REPOSITORY_KEY")
449 BUILD_ARGS+=(--build-arg REPOSITORY_BASE="$REPOSITORY_BASE")
450
451 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q KAFKA ; then
452 sg docker -c "docker pull wurstmeister/zookeeper" || FATAL "cannot get zookeeper docker image"
453 sg docker -c "docker pull wurstmeister/kafka:${KAFKA_TAG}" || FATAL "cannot get kafka docker image"
454 fi
455
456 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q MONGO ; then
457 sg docker -c "docker pull mongo" || FATAL "cannot get mongo docker image"
458 fi
459
460 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
461 sg docker -c "docker pull prom/prometheus:${PROMETHEUS_TAG}" || FATAL "cannot get prometheus docker image"
462 fi
463
464 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS-CADVISOR ; then
465 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
466 fi
467
468 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q GRAFANA ; then
469 sg docker -c "docker pull grafana/grafana:${GRAFANA_TAG}" || FATAL "cannot get grafana docker image"
470 fi
471
472 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI || echo $TO_REBUILD | grep -q KEYSTONE-DB ; then
473 sg docker -c "docker pull mariadb:${KEYSTONEDB_TAG}" || FATAL "cannot get keystone-db docker image"
474 fi
475
476 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
477 sg docker -c "docker pull mysql:5" || FATAL "cannot get mysql docker image"
478 fi
479
480 if [ -n "$PULL_IMAGES" ]; then
481 sg docker -c "docker pull ${DOCKER_USER}/mon:${OSM_DOCKER_TAG}" || FATAL "cannot pull MON docker image"
482 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q MON ; then
483 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/MON
484 git -C ${LWTEMPDIR}/MON checkout ${COMMIT_ID}
485 sg docker -c "docker build ${LWTEMPDIR}/MON -f ${LWTEMPDIR}/MON/docker/Dockerfile -t ${DOCKER_USER}/mon --no-cache" || FATAL "cannot build MON docker image"
486 fi
487
488 if [ -n "$PULL_IMAGES" ]; then
489 sg docker -c "docker pull ${DOCKER_USER}/pol:${OSM_DOCKER_TAG}" || FATAL "cannot pull POL docker image"
490 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q POL ; then
491 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/POL
492 git -C ${LWTEMPDIR}/POL checkout ${COMMIT_ID}
493 sg docker -c "docker build ${LWTEMPDIR}/POL -f ${LWTEMPDIR}/POL/docker/Dockerfile -t ${DOCKER_USER}/pol --no-cache" || FATAL "cannot build POL docker image"
494 fi
495
496 if [ -n "$PULL_IMAGES" -a -n "$INSTALL_PLA" ]; then
497 sg docker -c "docker pull ${DOCKER_USER}/pla:${OSM_DOCKER_TAG}" || FATAL "cannot pull PLA docker image"
498 elif [ -z "$TO_REBUILD" -a -n "$INSTALL_PLA" ] || echo $TO_REBUILD | grep -q PLA ; then
499 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/PLA
500 git -C ${LWTEMPDIR}/PLA checkout ${COMMIT_ID}
501 sg docker -c "docker build ${LWTEMPDIR}/PLA -f ${LWTEMPDIR}/PLA/docker/Dockerfile -t ${DOCKER_USER}/pla --no-cache" || FATAL "cannot build PLA docker image"
502 fi
503
504 if [ -n "$PULL_IMAGES" ]; then
505 sg docker -c "docker pull ${DOCKER_USER}/nbi:${OSM_DOCKER_TAG}" || FATAL "cannot pull NBI docker image"
506 sg docker -c "docker pull ${DOCKER_USER}/keystone:${OSM_DOCKER_TAG}" || FATAL "cannot pull KEYSTONE docker image"
507 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI ; then
508 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/NBI
509 git -C ${LWTEMPDIR}/NBI checkout ${COMMIT_ID}
510 sg docker -c "docker build ${LWTEMPDIR}/NBI -f ${LWTEMPDIR}/NBI/Dockerfile.local -t ${DOCKER_USER}/nbi --no-cache" || FATAL "cannot build NBI docker image"
511 sg docker -c "docker build ${LWTEMPDIR}/NBI/keystone -f ${LWTEMPDIR}/NBI/keystone/Dockerfile -t ${DOCKER_USER}/keystone --no-cache" || FATAL "cannot build KEYSTONE docker image"
512 fi
513
514 if [ -n "$PULL_IMAGES" ]; then
515 sg docker -c "docker pull ${DOCKER_USER}/ro:${OSM_DOCKER_TAG}" || FATAL "cannot pull RO docker image"
516 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
517 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/RO
518 git -C ${LWTEMPDIR}/RO checkout ${COMMIT_ID}
519 sg docker -c "docker build ${LWTEMPDIR}/RO -f ${LWTEMPDIR}/RO/Dockerfile-local -t ${DOCKER_USER}/ro --no-cache" || FATAL "cannot build RO docker image"
520 fi
521
522 if [ -n "$PULL_IMAGES" ]; then
523 sg docker -c "docker pull ${DOCKER_USER}/lcm:${OSM_DOCKER_TAG}" || FATAL "cannot pull LCM RO docker image"
524 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q LCM ; then
525 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/LCM
526 git -C ${LWTEMPDIR}/LCM checkout ${COMMIT_ID}
527 sg docker -c "docker build ${LWTEMPDIR}/LCM -f ${LWTEMPDIR}/LCM/Dockerfile.local -t ${DOCKER_USER}/lcm --no-cache" || FATAL "cannot build LCM docker image"
528 fi
529
530 if [ -n "$NGUI" ]; then
531 if [ -n "$PULL_IMAGES" ]; then
532 sg docker -c "docker pull ${DOCKER_USER}/ng-ui:${OSM_DOCKER_TAG}" || FATAL "cannot pull ng-ui docker image"
533 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NG-UI ; then
534 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/NG-UI
535 git -C ${LWTEMPDIR}/NG-UI checkout ${COMMIT_ID}
536 sg docker -c "docker build ${LWTEMPDIR}/NG-UI -f ${LWTEMPDIR}/NG-UI/docker/Dockerfile -t ${DOCKER_USER}/ng-ui --no-cache" || FATAL "cannot build NG-UI docker image"
537 fi
538 else
539 if [ -n "$PULL_IMAGES" ]; then
540 sg docker -c "docker pull ${DOCKER_USER}/light-ui:${OSM_DOCKER_TAG}" || FATAL "cannot pull light-ui docker image"
541 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q LW-UI ; then
542 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/LW-UI
543 git -C ${LWTEMPDIR}/LW-UI checkout ${COMMIT_ID}
544 sg docker -c "docker build ${LWTEMPDIR}/LW-UI -f ${LWTEMPDIR}/LW-UI/docker/Dockerfile -t ${DOCKER_USER}/light-ui --no-cache" || FATAL "cannot build LW-UI docker image"
545 fi
546 fi
547
548 if [ -n "$PULL_IMAGES" ]; then
549 sg docker -c "docker pull ${DOCKER_USER}/osmclient:${OSM_DOCKER_TAG}" || FATAL "cannot pull osmclient docker image"
550 elif [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q LW-osmclient; then
551 sg docker -c "docker build -t ${DOCKER_USER}/osmclient ${BUILD_ARGS[@]} -f $OSM_DEVOPS/docker/osmclient ."
552 fi
553
554 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
555 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
556 fi
557
558 echo "Finished generation of docker images"
559 }
560
561 function cmp_overwrite() {
562 file1="$1"
563 file2="$2"
564 if ! $(cmp "${file1}" "${file2}" >/dev/null 2>&1); then
565 if [ -f "${file2}" ]; then
566 ask_user "The file ${file2} already exists. Overwrite (y/N)? " n && cp -b ${file1} ${file2}
567 else
568 cp -b ${file1} ${file2}
569 fi
570 fi
571 }
572
573 function generate_docker_env_files() {
574 echo "Doing a backup of existing env files"
575 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/keystone-db.env{,~}
576 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/keystone.env{,~}
577 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/lcm.env{,~}
578 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/lwui.env{,~}
579 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/mon.env{,~}
580 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/nbi.env{,~}
581 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/pol.env{,~}
582 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/ro-db.env{,~}
583 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/ro.env{,~}
584
585 echo "Generating docker env files"
586 if [ -n "$KUBERNETES" ]; then
587 #Kubernetes resources
588 $WORKDIR_SUDO cp -bR ${OSM_DEVOPS}/installers/docker/osm_pods $OSM_DOCKER_WORK_DIR
589 [ -n "$NGUI" ] && $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/osm_pods/ng-ui.yaml $OSM_K8S_WORK_DIR/ng-ui.yaml && $WORKDIR_SUDO rm $OSM_K8S_WORK_DIR/light-ui.yaml
590 else
591 if [ -n "$NGUI" ]; then
592 # For NG-UI
593 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/docker-compose-ngui.yaml $OSM_DOCKER_WORK_DIR/docker-compose.yaml
594 else
595 # Docker-compose
596 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/docker-compose.yaml $OSM_DOCKER_WORK_DIR/docker-compose.yaml
597 fi
598 if [ -n "$INSTALL_PLA" ]; then
599 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/osm_pla/docker-compose.yaml $OSM_DOCKER_WORK_DIR/osm_pla/docker-compose.yaml
600 fi
601
602 # Prometheus files
603 $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/prometheus
604 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/prometheus/prometheus.yml $OSM_DOCKER_WORK_DIR/prometheus/prometheus.yml
605
606 # Grafana files
607 $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/grafana
608 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/dashboards-osm.yml $OSM_DOCKER_WORK_DIR/grafana/dashboards-osm.yml
609 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/datasource-prometheus.yml $OSM_DOCKER_WORK_DIR/grafana/datasource-prometheus.yml
610 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/osm-sample-dashboard.json $OSM_DOCKER_WORK_DIR/grafana/osm-sample-dashboard.json
611 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/osm-system-dashboard.json $OSM_DOCKER_WORK_DIR/grafana/osm-system-dashboard.json
612
613 # Prometheus Exporters files
614 $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/prometheus_exporters
615 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/prometheus_exporters/node_exporter.service $OSM_DOCKER_WORK_DIR/prometheus_exporters/node_exporter.service
616 fi
617
618 # LCM
619 if [ ! -f $OSM_DOCKER_WORK_DIR/lcm.env ]; then
620 echo "OSMLCM_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
621 fi
622
623 if ! grep -Fq "OSMLCM_VCA_HOST" $OSM_DOCKER_WORK_DIR/lcm.env; then
624 echo "OSMLCM_VCA_HOST=${OSM_VCA_HOST}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
625 else
626 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_HOST.*|OSMLCM_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/lcm.env
627 fi
628
629 if ! grep -Fq "OSMLCM_VCA_SECRET" $OSM_DOCKER_WORK_DIR/lcm.env; then
630 echo "OSMLCM_VCA_SECRET=${OSM_VCA_SECRET}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
631 else
632 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_SECRET.*|OSMLCM_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/lcm.env
633 fi
634
635 if ! grep -Fq "OSMLCM_VCA_PUBKEY" $OSM_DOCKER_WORK_DIR/lcm.env; then
636 echo "OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
637 else
638 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_PUBKEY.*|OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
639 fi
640
641 if ! grep -Fq "OSMLCM_VCA_CACERT" $OSM_DOCKER_WORK_DIR/lcm.env; then
642 echo "OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
643 else
644 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_CACERT.*|OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/lcm.env
645 fi
646
647 if ! grep -Fq "OSMLCM_VCA_APIPROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
648 echo "OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
649 else
650 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_APIPROXY.*|OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
651 fi
652
653 if ! grep -Fq "OSMLCM_VCA_ENABLEOSUPGRADE" $OSM_DOCKER_WORK_DIR/lcm.env; then
654 echo "# OSMLCM_VCA_ENABLEOSUPGRADE=false" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
655 fi
656
657 if ! grep -Fq "OSMLCM_VCA_APTMIRROR" $OSM_DOCKER_WORK_DIR/lcm.env; then
658 echo "# OSMLCM_VCA_APTMIRROR=http://archive.ubuntu.com/ubuntu/" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
659 fi
660
661 if ! grep -Fq "OSMLCM_VCA_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
662 echo "OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
663 else
664 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_CLOUD.*|OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
665 fi
666
667 # RO
668 MYSQL_ROOT_PASSWORD=$(generate_secret)
669 if [ ! -f $OSM_DOCKER_WORK_DIR/ro-db.env ]; then
670 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/ro-db.env
671 fi
672 if [ ! -f $OSM_DOCKER_WORK_DIR/ro.env ]; then
673 echo "RO_DB_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/ro.env
674 fi
675
676 # Keystone
677 KEYSTONE_DB_PASSWORD=$(generate_secret)
678 SERVICE_PASSWORD=$(generate_secret)
679 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone-db.env ]; then
680 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/keystone-db.env
681 fi
682 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone.env ]; then
683 echo "ROOT_DB_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/keystone.env
684 echo "KEYSTONE_DB_PASSWORD=${KEYSTONE_DB_PASSWORD}" |$WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/keystone.env
685 echo "SERVICE_PASSWORD=${SERVICE_PASSWORD}" |$WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/keystone.env
686 fi
687
688 # NBI
689 if [ ! -f $OSM_DOCKER_WORK_DIR/nbi.env ]; then
690 echo "OSMNBI_AUTHENTICATION_SERVICE_PASSWORD=${SERVICE_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/nbi.env
691 echo "OSMNBI_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/nbi.env
692 fi
693
694 # MON
695 if [ ! -f $OSM_DOCKER_WORK_DIR/mon.env ]; then
696 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
697 echo "OSMMON_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/mon" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
698 fi
699
700 if ! grep -Fq "OS_NOTIFIER_URI" $OSM_DOCKER_WORK_DIR/mon.env; then
701 echo "OS_NOTIFIER_URI=http://${DEFAULT_IP}:8662" |$WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
702 else
703 $WORKDIR_SUDO sed -i "s|OS_NOTIFIER_URI.*|OS_NOTIFIER_URI=http://$DEFAULT_IP:8662|g" $OSM_DOCKER_WORK_DIR/mon.env
704 fi
705
706 if ! grep -Fq "OSMMON_VCA_HOST" $OSM_DOCKER_WORK_DIR/mon.env; then
707 echo "OSMMON_VCA_HOST=${OSM_VCA_HOST}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
708 else
709 $WORKDIR_SUDO sed -i "s|OSMMON_VCA_HOST.*|OSMMON_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/mon.env
710 fi
711
712 if ! grep -Fq "OSMMON_VCA_SECRET" $OSM_DOCKER_WORK_DIR/mon.env; then
713 echo "OSMMON_VCA_SECRET=${OSM_VCA_SECRET}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
714 else
715 $WORKDIR_SUDO sed -i "s|OSMMON_VCA_SECRET.*|OSMMON_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/mon.env
716 fi
717
718 if ! grep -Fq "OSMMON_VCA_CACERT" $OSM_DOCKER_WORK_DIR/mon.env; then
719 echo "OSMMON_VCA_CACERT=${OSM_VCA_CACERT}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
720 else
721 $WORKDIR_SUDO sed -i "s|OSMMON_VCA_CACERT.*|OSMMON_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/mon.env
722 fi
723
724
725 # POL
726 if [ ! -f $OSM_DOCKER_WORK_DIR/pol.env ]; then
727 echo "OSMPOL_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/pol" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/pol.env
728 fi
729
730 # LW-UI
731 if [ ! -f $OSM_DOCKER_WORK_DIR/lwui.env ]; then
732 echo "OSMUI_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/lwui" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lwui.env
733 fi
734
735 echo "Finished generation of docker env files"
736 }
737
738 function generate_osmclient_script () {
739 echo "docker run -ti --network net${OSM_STACK_NAME} ${DOCKER_USER}/osmclient:${OSM_DOCKER_TAG}" | $WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/osm
740 $WORKDIR_SUDO chmod +x "$OSM_DOCKER_WORK_DIR/osm"
741 echo "osmclient sidecar container can be found at: $OSM_DOCKER_WORK_DIR/osm"
742 }
743
744 #installs kubernetes packages
745 function install_kube() {
746 sudo apt-get update && sudo apt-get install -y apt-transport-https
747 curl -fsSL https://packages.cloud.google.com/apt/doc/apt-key.gpg | sudo apt-key add -
748 sudo add-apt-repository "deb https://apt.kubernetes.io/ kubernetes-xenial main"
749 sudo apt-get update
750 echo "Installing Kubernetes Packages ..."
751 sudo apt-get install -y kubelet=1.15.0-00 kubeadm=1.15.0-00 kubectl=1.15.0-00
752 }
753
754 #initializes kubernetes control plane
755 function init_kubeadm() {
756 sudo swapoff -a
757 sudo kubeadm init --config $1
758 sleep 5
759 }
760
761 function kube_config_dir() {
762 [ ! -d $K8S_MANIFEST_DIR ] && FATAL "Cannot Install Kubernetes"
763 mkdir -p $HOME/.kube
764 sudo cp /etc/kubernetes/admin.conf $HOME/.kube/config
765 sudo chown $(id -u):$(id -g) $HOME/.kube/config
766 }
767
768 #deploys flannel as daemonsets
769 function deploy_cni_provider() {
770 CNI_DIR="$(mktemp -d -q --tmpdir "flannel.XXXXXX")"
771 trap 'rm -rf "${CNI_DIR}"' EXIT
772 wget -q https://raw.githubusercontent.com/coreos/flannel/master/Documentation/kube-flannel.yml -P $CNI_DIR
773 kubectl apply -f $CNI_DIR
774 [ $? -ne 0 ] && FATAL "Cannot Install Flannel"
775 }
776
777 #creates secrets from env files which will be used by containers
778 function kube_secrets(){
779 kubectl create ns $OSM_STACK_NAME
780 kubectl create secret generic lcm-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/lcm.env
781 kubectl create secret generic mon-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/mon.env
782 kubectl create secret generic nbi-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/nbi.env
783 kubectl create secret generic ro-db-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro-db.env
784 kubectl create secret generic ro-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro.env
785 kubectl create secret generic keystone-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/keystone.env
786 kubectl create secret generic lwui-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/lwui.env
787 kubectl create secret generic pol-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/pol.env
788 }
789
790 #deploys osm pods and services
791 function deploy_osm_services() {
792 K8S_MASTER=$(kubectl get nodes | awk '$3~/master/'| awk '{print $1}')
793 kubectl taint node $K8S_MASTER node-role.kubernetes.io/master:NoSchedule-
794 sleep 5
795 kubectl apply -n $OSM_STACK_NAME -f $OSM_K8S_WORK_DIR
796 }
797
798 function deploy_osm_pla_service() {
799 # corresponding to parse_yaml
800 [ ! $OSM_DOCKER_TAG == "7" ] && $WORKDIR_SUDO sed -i "s/opensourcemano\/pla:.*/opensourcemano\/pla:$OSM_DOCKER_TAG/g" $OSM_DOCKER_WORK_DIR/osm_pla/pla.yaml
801 # corresponding to namespace_vol
802 $WORKDIR_SUDO sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_DOCKER_WORK_DIR/osm_pla/pla.yaml
803 # corresponding to deploy_osm_services
804 kubectl apply -n $OSM_STACK_NAME -f $OSM_DOCKER_WORK_DIR/osm_pla
805 }
806
807 #Install helm and tiller
808 function install_helm() {
809 helm > /dev/null 2>&1
810 if [ $? != 0 ] ; then
811 # Helm is not installed. Install helm
812 curl https://get.helm.sh/helm-v2.15.2-linux-amd64.tar.gz --output helm-v2.15.2.tar.gz
813 tar -zxvf helm-v2.15.2.tar.gz
814 sudo mv linux-amd64/helm /usr/local/bin/helm
815 rm -r linux-amd64
816 rm helm-v2.15.2.tar.gz
817 fi
818
819 # Checking if tiller has being configured
820 kubectl --namespace kube-system get serviceaccount tiller > /dev/null 2>&1
821 if [ $? == 1 ] ; then
822 # tiller account for kubernetes
823 kubectl --namespace kube-system create serviceaccount tiller
824 kubectl create clusterrolebinding tiller-cluster-rule --clusterrole=cluster-admin --serviceaccount=kube-system:tiller
825 # HELM initialization
826 helm init --service-account tiller
827
828 # Wait for Tiller to be up and running. If timeout expires, continue installing
829 tiller_timeout=120; counter=0
830 while (( counter < tiller_timeout ))
831 do
832 tiller_status=`kubectl -n kube-system get deployment.apps/tiller-deploy --no-headers | awk '{print $2'}`
833 ( [ ! -z "$tiller_status" ] && [ $tiller_status == "1/1" ] ) && break
834 num=$((counter + 2))
835 sleep 2
836 done
837 fi
838 }
839
840 function parse_yaml() {
841 osm_services="nbi lcm ro pol mon light-ui ng-ui keystone"
842 TAG=$1
843 for osm in $osm_services; do
844 $WORKDIR_SUDO sed -i "s/opensourcemano\/$osm:.*/$DOCKER_USER\/$osm:$TAG/g" $OSM_K8S_WORK_DIR/$osm.yaml
845 done
846 }
847
848 function namespace_vol() {
849 osm_services="nbi lcm ro pol mon kafka mongo mysql"
850 for osm in $osm_services; do
851 $WORKDIR_SUDO sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_K8S_WORK_DIR/$osm.yaml
852 done
853 }
854
855 function init_docker_swarm() {
856 if [ "${DEFAULT_MTU}" != "1500" ]; then
857 DOCKER_NETS=`sg docker -c "docker network list" | awk '{print $2}' | egrep -v "^ID$" | paste -d " " -s`
858 DOCKER_GW_NET=`sg docker -c "docker network inspect ${DOCKER_NETS}" | grep Subnet | awk -F\" '{print $4}' | egrep "^172" | sort -u | tail -1 | awk -F\. '{if ($2 != 255) print $1"."$2+1"."$3"."$4; else print "-1";}'`
859 sg docker -c "docker network create --subnet ${DOCKER_GW_NET} --opt com.docker.network.bridge.name=docker_gwbridge --opt com.docker.network.bridge.enable_icc=false --opt com.docker.network.bridge.enable_ip_masquerade=true --opt com.docker.network.driver.mtu=${DEFAULT_MTU} docker_gwbridge"
860 fi
861 sg docker -c "docker swarm init --advertise-addr ${DEFAULT_IP}"
862 return 0
863 }
864
865 function create_docker_network() {
866 echo "creating network"
867 sg docker -c "docker network create --driver=overlay --attachable --opt com.docker.network.driver.mtu=${DEFAULT_MTU} net${OSM_STACK_NAME}"
868 echo "creating network DONE"
869 }
870
871 function deploy_lightweight() {
872
873 echo "Deploying lightweight build"
874 OSM_NBI_PORT=9999
875 OSM_RO_PORT=9090
876 OSM_KEYSTONE_PORT=5000
877 OSM_UI_PORT=80
878 OSM_MON_PORT=8662
879 OSM_PROM_PORT=9090
880 OSM_PROM_CADVISOR_PORT=8080
881 OSM_PROM_HOSTPORT=9091
882 OSM_GRAFANA_PORT=3000
883 [ -n "$INSTALL_ELK" ] && OSM_ELK_PORT=5601
884 #[ -n "$INSTALL_PERFMON" ] && OSM_PM_PORT=3000
885
886 if [ -n "$NO_HOST_PORTS" ]; then
887 OSM_PORTS+=(OSM_NBI_PORTS=$OSM_NBI_PORT)
888 OSM_PORTS+=(OSM_RO_PORTS=$OSM_RO_PORT)
889 OSM_PORTS+=(OSM_KEYSTONE_PORTS=$OSM_KEYSTONE_PORT)
890 OSM_PORTS+=(OSM_UI_PORTS=$OSM_UI_PORT)
891 OSM_PORTS+=(OSM_MON_PORTS=$OSM_MON_PORT)
892 OSM_PORTS+=(OSM_PROM_PORTS=$OSM_PROM_PORT)
893 OSM_PORTS+=(OSM_PROM_CADVISOR_PORTS=$OSM_PROM_CADVISOR_PORT)
894 OSM_PORTS+=(OSM_GRAFANA_PORTS=$OSM_GRAFANA_PORT)
895 #[ -n "$INSTALL_PERFMON" ] && OSM_PORTS+=(OSM_PM_PORTS=$OSM_PM_PORT)
896 [ -n "$INSTALL_ELK" ] && OSM_PORTS+=(OSM_ELK_PORTS=$OSM_ELK_PORT)
897 else
898 OSM_PORTS+=(OSM_NBI_PORTS=$OSM_NBI_PORT:$OSM_NBI_PORT)
899 OSM_PORTS+=(OSM_RO_PORTS=$OSM_RO_PORT:$OSM_RO_PORT)
900 OSM_PORTS+=(OSM_KEYSTONE_PORTS=$OSM_KEYSTONE_PORT:$OSM_KEYSTONE_PORT)
901 OSM_PORTS+=(OSM_UI_PORTS=$OSM_UI_PORT:$OSM_UI_PORT)
902 OSM_PORTS+=(OSM_MON_PORTS=$OSM_MON_PORT:$OSM_MON_PORT)
903 OSM_PORTS+=(OSM_PROM_PORTS=$OSM_PROM_HOSTPORT:$OSM_PROM_PORT)
904 OSM_PORTS+=(OSM_PROM_CADVISOR_PORTS=$OSM_PROM_CADVISOR_PORT:$OSM_PROM_CADVISOR_PORT)
905 OSM_PORTS+=(OSM_GRAFANA_PORTS=$OSM_GRAFANA_PORT:$OSM_GRAFANA_PORT)
906 #[ -n "$INSTALL_PERFMON" ] && OSM_PORTS+=(OSM_PM_PORTS=$OSM_PM_PORT:$OSM_PM_PORT)
907 [ -n "$INSTALL_ELK" ] && OSM_PORTS+=(OSM_ELK_PORTS=$OSM_ELK_PORT:$OSM_ELK_PORT)
908 fi
909 echo "export ${OSM_PORTS[@]}" | $WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/osm_ports.sh
910 echo "export OSM_NETWORK=net${OSM_STACK_NAME}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
911 echo "export TAG=${OSM_DOCKER_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
912 echo "export DOCKER_USER=${DOCKER_USER}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
913 echo "export KAFKA_TAG=${KAFKA_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
914 echo "export PROMETHEUS_TAG=${PROMETHEUS_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
915 echo "export KEYSTONEDB_TAG=${KEYSTONEDB_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
916 echo "export PROMETHEUS_CADVISOR_TAG=${PROMETHEUS_CADVISOR_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
917 echo "export GRAFANA_TAG=${GRAFANA_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
918
919 pushd $OSM_DOCKER_WORK_DIR
920 if [ -n "$INSTALL_PLA" ]; then
921 sg docker -c ". ./osm_ports.sh; docker stack deploy -c $OSM_DOCKER_WORK_DIR/docker-compose.yaml -c $OSM_DOCKER_WORK_DIR/osm_pla/docker-compose.yaml $OSM_STACK_NAME"
922 else
923 sg docker -c ". ./osm_ports.sh; docker stack deploy -c $OSM_DOCKER_WORK_DIR/docker-compose.yaml $OSM_STACK_NAME"
924 fi
925 popd
926
927 echo "Finished deployment of lightweight build"
928 }
929
930 function deploy_elk() {
931 echo "Pulling docker images for ELK"
932 sg docker -c "docker pull docker.elastic.co/elasticsearch/elasticsearch-oss:${ELASTIC_VERSION}" || FATAL "cannot get elasticsearch docker image"
933 sg docker -c "docker pull docker.elastic.co/beats/metricbeat:${ELASTIC_VERSION}" || FATAL "cannot get metricbeat docker image"
934 sg docker -c "docker pull docker.elastic.co/beats/filebeat:${ELASTIC_VERSION}" || FATAL "cannot get filebeat docker image"
935 sg docker -c "docker pull docker.elastic.co/kibana/kibana-oss:${ELASTIC_VERSION}" || FATAL "cannot get kibana docker image"
936 sg docker -c "docker pull bobrik/curator:${ELASTIC_CURATOR_VERSION}" || FATAL "cannot get curator docker image"
937 echo "Finished pulling elk docker images"
938 $WORKDIR_SUDO mkdir -p "$OSM_DOCKER_WORK_DIR/osm_elk"
939 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/osm_elk/* $OSM_DOCKER_WORK_DIR/osm_elk
940 remove_stack osm_elk
941 echo "Deploying ELK stack"
942 sg docker -c "OSM_NETWORK=net${OSM_STACK_NAME} docker stack deploy -c $OSM_DOCKER_WORK_DIR/osm_elk/docker-compose.yml osm_elk"
943 echo "Waiting for ELK stack to be up and running"
944 time=0
945 step=5
946 timelength=40
947 elk_is_up=1
948 while [ $time -le $timelength ]; do
949 if [[ $(curl -f -XGET http://127.0.0.1:5601/status -I 2>/dev/null | grep "HTTP/1.1 200 OK" | wc -l ) -eq 1 ]]; then
950 elk_is_up=0
951 break
952 fi
953 sleep $step
954 time=$((time+step))
955 done
956 if [ $elk_is_up -eq 0 ]; then
957 echo "ELK is up and running. Trying to create index pattern..."
958 #Create index pattern
959 curl -f -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
960 "http://127.0.0.1:5601/api/saved_objects/index-pattern/filebeat-*" \
961 -d"{\"attributes\":{\"title\":\"filebeat-*\",\"timeFieldName\":\"@timestamp\"}}" 2>/dev/null
962 #Make it the default index
963 curl -f -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
964 "http://127.0.0.1:5601/api/kibana/settings/defaultIndex" \
965 -d"{\"value\":\"filebeat-*\"}" 2>/dev/null
966 else
967 echo "Cannot connect to Kibana to create index pattern."
968 echo "Once Kibana is running, you can use the following instructions to create index pattern:"
969 echo 'curl -f -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
970 "http://127.0.0.1:5601/api/saved_objects/index-pattern/filebeat-*" \
971 -d"{\"attributes\":{\"title\":\"filebeat-*\",\"timeFieldName\":\"@timestamp\"}}"'
972 echo 'curl -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
973 "http://127.0.0.1:5601/api/kibana/settings/defaultIndex" \
974 -d"{\"value\":\"filebeat-*\"}"'
975 fi
976 echo "Finished deployment of ELK stack"
977 return 0
978 }
979
980 function install_lightweight() {
981 [ "${OSM_STACK_NAME}" == "osm" ] || OSM_DOCKER_WORK_DIR="$OSM_WORK_DIR/stack/$OSM_STACK_NAME"
982 [ -n "$KUBERNETES" ] && OSM_K8S_WORK_DIR="$OSM_DOCKER_WORK_DIR/osm_pods" && OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
983 [ ! -d "$OSM_DOCKER_WORK_DIR" ] && $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR
984 [ ! -d "$OSM_DOCKER_WORK_DIR/osm_pla" -a -n "$INSTALL_PLA" ] && $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/osm_pla
985 [ -n "$KUBERNETES" ] && $WORKDIR_SUDO cp -b $OSM_DEVOPS/installers/docker/cluster-config.yaml $OSM_DOCKER_WORK_DIR/cluster-config.yaml
986
987 track checkingroot
988 [ "$USER" == "root" ] && FATAL "You are running the installer as root. The installer is prepared to be executed as a normal user with sudo privileges."
989 track noroot
990
991 if [ -n "$KUBERNETES" ]; then
992 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will do the following
993 1. Install and configure LXD
994 2. Install juju
995 3. Install docker CE
996 4. Disable swap space
997 5. Install and initialize Kubernetes
998 as pre-requirements.
999 Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
1000
1001 else
1002 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will configure LXD, install juju, install docker CE and init a docker swarm, as pre-requirements. Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
1003 fi
1004 track proceed
1005
1006 echo "Installing lightweight build of OSM"
1007 LWTEMPDIR="$(mktemp -d -q --tmpdir "installosmlight.XXXXXX")"
1008 trap 'rm -rf "${LWTEMPDIR}"' EXIT
1009 DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
1010 [ -z "$DEFAULT_IF" ] && DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
1011 [ -z "$DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
1012 DEFAULT_IP=`ip -o -4 a |grep ${DEFAULT_IF} |awk '{split($4,a,"/"); print a[1]}'`
1013 [ -z "$DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
1014 DEFAULT_MTU=$(ip addr show ${DEFAULT_IF} | perl -ne 'if (/mtu\s(\d+)/) {print $1;}')
1015
1016 # if no host is passed in, we need to install lxd/juju, unless explicilty asked not to
1017 if [ -z "$OSM_VCA_HOST" ] && [ -z "$INSTALL_NOLXD" ] && [ -z "$LXD_CLOUD_FILE" ]; then
1018 need_packages_lw="snapd"
1019 echo -e "Checking required packages: $need_packages_lw"
1020 dpkg -l $need_packages_lw &>/dev/null \
1021 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
1022 || sudo apt-get update \
1023 || FATAL "failed to run apt-get update"
1024 dpkg -l $need_packages_lw &>/dev/null \
1025 || ! echo -e "Installing $need_packages_lw requires root privileges." \
1026 || sudo apt-get install -y $need_packages_lw \
1027 || FATAL "failed to install $need_packages_lw"
1028 install_lxd
1029 fi
1030
1031 track prereqok
1032
1033 [ -z "$INSTALL_NOJUJU" ] && install_juju
1034 track juju_install
1035
1036 if [ -z "$OSM_VCA_HOST" ]; then
1037 if [ -z "$CONTROLLER_NAME" ]; then
1038 if [ -n "$LXD_CLOUD_FILE" ]; then
1039 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
1040 OSM_VCA_CLOUDNAME="lxd-cloud"
1041 juju add-cloud $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud $OSM_VCA_CLOUDNAME --client -f $LXD_CLOUD_FILE
1042 juju add-credential $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential $OSM_VCA_CLOUDNAME lxd-cloud-creds -f $LXD_CRED_FILE
1043 fi
1044 juju_createcontroller
1045 else
1046 OSM_VCA_CLOUDNAME="lxd-cloud"
1047 if [ -n "$LXD_CLOUD_FILE" ]; then
1048 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
1049 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f $LXD_CLOUD_FILE
1050 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f $LXD_CRED_FILE
1051 else
1052 mkdir -p ~/.osm
1053 cat << EOF > ~/.osm/lxd-cloud.yaml
1054 clouds:
1055 lxd-cloud:
1056 type: lxd
1057 auth-types: [certificate]
1058 endpoint: "https://$DEFAULT_IP:8443"
1059 config:
1060 ssl-hostname-verification: false
1061 EOF
1062 openssl req -nodes -new -x509 -keyout ~/.osm/client.key -out ~/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
1063 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
1064 local client_cert=`cat ~/.osm/client.crt | sed 's/^/ /'`
1065 local client_key=`cat ~/.osm/client.key | sed 's/^/ /'`
1066 cat << EOF > ~/.osm/lxd-credentials.yaml
1067 credentials:
1068 lxd-cloud:
1069 lxd-cloud:
1070 auth-type: certificate
1071 server-cert: |
1072 $server_cert
1073 client-cert: |
1074 $client_cert
1075 client-key: |
1076 $client_key
1077 EOF
1078 lxc config trust add local: ~/.osm/client.crt
1079 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME ~/.osm/lxd-cloud.yaml --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-cloud.yaml
1080 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f ~/.osm/lxd-credentials.yaml || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-credentials.yaml
1081 fi
1082 fi
1083 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_STACK_NAME"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
1084 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
1085 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
1086 fi
1087 track juju_controller
1088
1089 if [ -z "$OSM_VCA_SECRET" ]; then
1090 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $OSM_STACK_NAME)
1091 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $CONTROLLER_NAME)
1092 [ -z "$OSM_VCA_SECRET" ] && FATAL "Cannot obtain juju secret"
1093 fi
1094 if [ -z "$OSM_VCA_PUBKEY" ]; then
1095 OSM_VCA_PUBKEY=$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)
1096 [ -z "$OSM_VCA_PUBKEY" ] && FATAL "Cannot obtain juju public key"
1097 fi
1098 if [ -z "$OSM_VCA_CACERT" ]; then
1099 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $OSM_STACK_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
1100 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $CONTROLLER_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
1101 [ -z "$OSM_VCA_CACERT" ] && FATAL "Cannot obtain juju CA certificate"
1102 fi
1103 if [ -z "$OSM_VCA_APIPROXY" ]; then
1104 OSM_VCA_APIPROXY=$DEFAULT_IP
1105 [ -z "$OSM_VCA_APIPROXY" ] && FATAL "Cannot obtain juju api proxy"
1106 fi
1107 juju_createproxy
1108 track juju
1109
1110 if [ -z "$OSM_DATABASE_COMMONKEY" ]; then
1111 OSM_DATABASE_COMMONKEY=$(generate_secret)
1112 [ -z "OSM_DATABASE_COMMONKEY" ] && FATAL "Cannot generate common db secret"
1113 fi
1114
1115 [ -n "$INSTALL_NODOCKER" ] || install_docker_ce
1116 track docker_ce
1117
1118 #Installs Kubernetes and deploys osm services
1119 if [ -n "$KUBERNETES" ]; then
1120 install_kube
1121 track install_k8s
1122 init_kubeadm $OSM_DOCKER_WORK_DIR/cluster-config.yaml
1123 kube_config_dir
1124 track init_k8s
1125 else
1126 #install_docker_compose
1127 [ -n "$INSTALL_NODOCKER" ] || init_docker_swarm
1128 track docker_swarm
1129 fi
1130
1131 [ -z "$DOCKER_NOBUILD" ] && generate_docker_images
1132 track docker_build
1133
1134 generate_docker_env_files
1135
1136 if [ -n "$KUBERNETES" ]; then
1137 if [ -n "$INSTALL_K8S_MONITOR" ]; then
1138 # uninstall OSM MONITORING
1139 uninstall_k8s_monitoring
1140 track uninstall_k8s_monitoring
1141 fi
1142 #remove old namespace
1143 remove_k8s_namespace $OSM_STACK_NAME
1144 deploy_cni_provider
1145 kube_secrets
1146 [ ! $OSM_DOCKER_TAG == "7" ] && parse_yaml $OSM_DOCKER_TAG
1147 namespace_vol
1148 deploy_osm_services
1149 if [ -n "$INSTALL_PLA"]; then
1150 # optional PLA install
1151 deploy_osm_pla_service
1152 fi
1153 track deploy_osm_services_k8s
1154 if [ -n "$INSTALL_K8S_MONITOR" ]; then
1155 # install OSM MONITORING
1156 install_k8s_monitoring
1157 track install_k8s_monitoring
1158 fi
1159 else
1160 # remove old stack
1161 remove_stack $OSM_STACK_NAME
1162 create_docker_network
1163 deploy_lightweight
1164 generate_osmclient_script
1165 track docker_deploy
1166 install_prometheus_nodeexporter
1167 track nodeexporter
1168 [ -n "$INSTALL_VIMEMU" ] && install_vimemu && track vimemu
1169 [ -n "$INSTALL_ELK" ] && deploy_elk && track elk
1170 fi
1171
1172 [ -z "$INSTALL_NOHOSTCLIENT" ] && install_osmclient
1173 track osmclient
1174
1175 echo -e "Checking OSM health state..."
1176 if [ -n "$KUBERNETES" ]; then
1177 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_STACK_NAME} -k || \
1178 echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
1179 echo -e "Check OSM status with: kubectl -n ${OSM_STACK_NAME} get all" && \
1180 track osm_unhealthy
1181 else
1182 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_STACK_NAME} || \
1183 echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
1184 echo -e "Check OSM status with: docker service ls; docker stack ps ${OSM_STACK_NAME}" && \
1185 track osm_unhealthy
1186 fi
1187 track after_healthcheck
1188
1189 wget -q -O- https://osm-download.etsi.org/ftp/osm-8.0-eight/README2.txt &> /dev/null
1190 track end
1191 return 0
1192 }
1193
1194 function install_to_openstack() {
1195
1196 if [ -z "$2" ]; then
1197 FATAL "OpenStack installer requires a valid external network name"
1198 fi
1199
1200 # Install Pip for Python3
1201 $WORKDIR_SUDO apt install -y python3-pip
1202 $WORKDIR_SUDO -H LC_ALL=C python3 -m pip install -U pip
1203
1204 # Install Ansible, OpenStack client and SDK
1205 $WORKDIR_SUDO -H LC_ALL=C python3 -m pip install -U python-openstackclient "openstacksdk<1" "ansible>=2.9,<3"
1206
1207 export ANSIBLE_CONFIG="$OSM_DEVOPS/installers/openstack/ansible.cfg"
1208
1209 OSM_INSTALLER_ARGS="${REPO_ARGS[@]}"
1210
1211 # Execute the Ansible playbook based on openrc or clouds.yaml
1212 if [ -e "$1" ]; then
1213 . $1
1214 ansible-playbook -e external_network_name=$2 -e installer_args="\"$OSM_INSTALLER_ARGS\"" \
1215 -e setup_volume=$3 $OSM_DEVOPS/installers/openstack/site.yml
1216 else
1217 ansible-playbook -e external_network_name=$2 -e installer_args="\"$OSM_INSTALLER_ARGS\"" \
1218 -e setup_volume=$3 -e cloud_name=$1 $OSM_DEVOPS/installers/openstack/site.yml
1219 fi
1220
1221 return 0
1222 }
1223
1224 function install_vimemu() {
1225 echo "\nInstalling vim-emu"
1226 EMUTEMPDIR="$(mktemp -d -q --tmpdir "installosmvimemu.XXXXXX")"
1227 trap 'rm -rf "${EMUTEMPDIR}"' EXIT
1228 # install prerequisites (OVS is a must for the emulator to work)
1229 sudo apt-get install openvswitch-switch
1230 # clone vim-emu repository (attention: branch is currently master only)
1231 echo "Cloning vim-emu repository ..."
1232 git clone https://osm.etsi.org/gerrit/osm/vim-emu.git $EMUTEMPDIR
1233 # build vim-emu docker
1234 echo "Building vim-emu Docker container..."
1235
1236 sg docker -c "docker build -t vim-emu-img -f $EMUTEMPDIR/Dockerfile --no-cache $EMUTEMPDIR/" || FATAL "cannot build vim-emu-img docker image"
1237 # start vim-emu container as daemon
1238 echo "Starting vim-emu Docker container 'vim-emu' ..."
1239 if [ -n "$INSTALL_LIGHTWEIGHT" ]; then
1240 # in lightweight mode, the emulator needs to be attached to netOSM
1241 sg docker -c "docker run --name vim-emu -t -d --restart always --privileged --pid='host' --network=net${OSM_STACK_NAME} -v /var/run/docker.sock:/var/run/docker.sock vim-emu-img python examples/osm_default_daemon_topology_2_pop.py"
1242 else
1243 # classic build mode
1244 sg docker -c "docker run --name vim-emu -t -d --restart always --privileged --pid='host' -v /var/run/docker.sock:/var/run/docker.sock vim-emu-img python examples/osm_default_daemon_topology_2_pop.py"
1245 fi
1246 echo "Waiting for 'vim-emu' container to start ..."
1247 sleep 5
1248 export VIMEMU_HOSTNAME=$(sg docker -c "docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' vim-emu")
1249 echo "vim-emu running at ${VIMEMU_HOSTNAME} ..."
1250 # print vim-emu connection info
1251 echo -e "\nYou might be interested in adding the following vim-emu env variables to your .bashrc file:"
1252 echo " export VIMEMU_HOSTNAME=${VIMEMU_HOSTNAME}"
1253 echo -e "To add the emulated VIM to OSM you should do:"
1254 echo " osm vim-create --name emu-vim1 --user username --password password --auth_url http://${VIMEMU_HOSTNAME}:6001/v2.0 --tenant tenantName --account_type openstack"
1255 }
1256
1257 function install_k8s_monitoring() {
1258 # install OSM monitoring
1259 $WORKDIR_SUDO chmod +x $OSM_DEVOPS/installers/k8s/*.sh
1260 $WORKDIR_SUDO $OSM_DEVOPS/installers/k8s/install_osm_k8s_monitoring.sh
1261 }
1262
1263 function uninstall_k8s_monitoring() {
1264 # uninstall OSM monitoring
1265 $WORKDIR_SUDO $OSM_DEVOPS/installers/k8s/uninstall_osm_k8s_monitoring.sh
1266 }
1267
1268 function dump_vars(){
1269 echo "DEVELOP=$DEVELOP"
1270 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
1271 echo "UNINSTALL=$UNINSTALL"
1272 echo "UPDATE=$UPDATE"
1273 echo "RECONFIGURE=$RECONFIGURE"
1274 echo "TEST_INSTALLER=$TEST_INSTALLER"
1275 echo "INSTALL_VIMEMU=$INSTALL_VIMEMU"
1276 echo "INSTALL_PLA=$INSTALL_PLA"
1277 echo "INSTALL_LXD=$INSTALL_LXD"
1278 echo "INSTALL_LIGHTWEIGHT=$INSTALL_LIGHTWEIGHT"
1279 echo "INSTALL_ONLY=$INSTALL_ONLY"
1280 echo "INSTALL_ELK=$INSTALL_ELK"
1281 #echo "INSTALL_PERFMON=$INSTALL_PERFMON"
1282 echo "INSTALL_TO_OPENSTACK=$INSTALL_TO_OPENSTACK"
1283 echo "OPENSTACK_PUBLIC_NET_NAME=$OPENSTACK_PUBLIC_NET_NAME"
1284 echo "OPENSTACK_OPENRC_FILE_OR_CLOUD=$OPENSTACK_OPENRC_FILE_OR_CLOUD"
1285 echo "OPENSTACK_ATTACH_VOLUME=$OPENSTACK_ATTACH_VOLUME"
1286 echo "INSTALL_K8S_MONITOR=$INSTALL_K8S_MONITOR"
1287 echo "TO_REBUILD=$TO_REBUILD"
1288 echo "INSTALL_NOLXD=$INSTALL_NOLXD"
1289 echo "INSTALL_NODOCKER=$INSTALL_NODOCKER"
1290 echo "INSTALL_NOJUJU=$INSTALL_NOJUJU"
1291 echo "RELEASE=$RELEASE"
1292 echo "REPOSITORY=$REPOSITORY"
1293 echo "REPOSITORY_BASE=$REPOSITORY_BASE"
1294 echo "REPOSITORY_KEY=$REPOSITORY_KEY"
1295 echo "OSM_DEVOPS=$OSM_DEVOPS"
1296 echo "OSM_VCA_HOST=$OSM_VCA_HOST"
1297 echo "OSM_VCA_SECRET=$OSM_VCA_SECRET"
1298 echo "OSM_VCA_PUBKEY=$OSM_VCA_PUBKEY"
1299 echo "NO_HOST_PORTS=$NO_HOST_PORTS"
1300 echo "DOCKER_NOBUILD=$DOCKER_NOBUILD"
1301 echo "WORKDIR_SUDO=$WORKDIR_SUDO"
1302 echo "OSM_WORK_DIR=$OSM_STACK_NAME"
1303 echo "OSM_DOCKER_TAG=$OSM_DOCKER_TAG"
1304 echo "DOCKER_USER=$DOCKER_USER"
1305 echo "OSM_STACK_NAME=$OSM_STACK_NAME"
1306 echo "PULL_IMAGES=$PULL_IMAGES"
1307 echo "KUBERNETES=$KUBERNETES"
1308 echo "NGUI=$NGUI"
1309 echo "SHOWOPTS=$SHOWOPTS"
1310 echo "Install from specific refspec (-b): $COMMIT_ID"
1311 }
1312
1313 function track(){
1314 ctime=`date +%s`
1315 duration=$((ctime - SESSION_ID))
1316 url="http://www.woopra.com/track/ce?project=osm.etsi.org&cookie=${SESSION_ID}"
1317 #url="${url}&ce_campaign_name=${CAMPAIGN_NAME}"
1318 event_name="bin"
1319 [ -z "$INSTALL_LIGHTWEIGHT" ] && [ -n "$INSTALL_FROM_SOURCE" ] && event_name="binsrc"
1320 [ -z "$INSTALL_LIGHTWEIGHT" ] && [ -n "$INSTALL_FROM_LXDIMAGES" ] && event_name="lxd"
1321 [ -n "$INSTALL_LIGHTWEIGHT" ] && event_name="lw"
1322 event_name="${event_name}_$1"
1323 url="${url}&event=${event_name}&ce_duration=${duration}"
1324 wget -q -O /dev/null $url
1325 }
1326
1327 UNINSTALL=""
1328 DEVELOP=""
1329 UPDATE=""
1330 RECONFIGURE=""
1331 TEST_INSTALLER=""
1332 INSTALL_LXD=""
1333 SHOWOPTS=""
1334 COMMIT_ID=""
1335 ASSUME_YES=""
1336 INSTALL_FROM_SOURCE=""
1337 RELEASE="ReleaseEIGHT"
1338 REPOSITORY="stable"
1339 INSTALL_VIMEMU=""
1340 INSTALL_PLA=""
1341 LXD_REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/lxd"
1342 LXD_REPOSITORY_PATH=""
1343 INSTALL_LIGHTWEIGHT="y"
1344 INSTALL_TO_OPENSTACK=""
1345 OPENSTACK_OPENRC_FILE_OR_CLOUD=""
1346 OPENSTACK_PUBLIC_NET_NAME=""
1347 OPENSTACK_ATTACH_VOLUME="false"
1348 INSTALL_ONLY=""
1349 INSTALL_ELK=""
1350 TO_REBUILD=""
1351 INSTALL_NOLXD=""
1352 INSTALL_NODOCKER=""
1353 INSTALL_NOJUJU=""
1354 KUBERNETES=""
1355 NGUI=""
1356 INSTALL_K8S_MONITOR=""
1357 INSTALL_NOHOSTCLIENT=""
1358 SESSION_ID=`date +%s`
1359 OSM_DEVOPS=
1360 OSM_VCA_HOST=
1361 OSM_VCA_SECRET=
1362 OSM_VCA_PUBKEY=
1363 OSM_VCA_CLOUDNAME="localhost"
1364 OSM_STACK_NAME=osm
1365 NO_HOST_PORTS=""
1366 DOCKER_NOBUILD=""
1367 REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
1368 REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/debian"
1369 WORKDIR_SUDO=sudo
1370 OSM_WORK_DIR="/etc/osm"
1371 OSM_DOCKER_WORK_DIR="/etc/osm/docker"
1372 OSM_K8S_WORK_DIR="${OSM_DOCKER_WORK_DIR}/osm_pods"
1373 OSM_HOST_VOL="/var/lib/osm"
1374 OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
1375 OSM_DOCKER_TAG=latest
1376 DOCKER_USER=opensourcemano
1377 PULL_IMAGES="y"
1378 KAFKA_TAG=2.11-1.0.2
1379 PROMETHEUS_TAG=v2.4.3
1380 GRAFANA_TAG=latest
1381 PROMETHEUS_NODE_EXPORTER_TAG=0.18.1
1382 PROMETHEUS_CADVISOR_TAG=latest
1383 KEYSTONEDB_TAG=10
1384 OSM_DATABASE_COMMONKEY=
1385 ELASTIC_VERSION=6.4.2
1386 ELASTIC_CURATOR_VERSION=5.5.4
1387 POD_NETWORK_CIDR=10.244.0.0/16
1388 K8S_MANIFEST_DIR="/etc/kubernetes/manifests"
1389 RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
1390
1391 while getopts ":b:r:c:n:k:u:R:D:o:O:m:N:H:S:s:w:t:U:P:A:l:L:K:-: hy" o; do
1392 case "${o}" in
1393 b)
1394 COMMIT_ID=${OPTARG}
1395 PULL_IMAGES=""
1396 ;;
1397 r)
1398 REPOSITORY="${OPTARG}"
1399 REPO_ARGS+=(-r "$REPOSITORY")
1400 ;;
1401 c)
1402 [ "${OPTARG}" == "swarm" ] && continue
1403 [ "${OPTARG}" == "k8s" ] && KUBERNETES="y" && continue
1404 echo -e "Invalid argument for -i : ' $OPTARG'\n" >&2
1405 usage && exit 1
1406 ;;
1407 n)
1408 [ "${OPTARG}" == "lwui" ] && continue
1409 [ "${OPTARG}" == "ngui" ] && NGUI="y" && continue
1410 echo -e "Invalid argument for -n : ' $OPTARG'\n" >&2
1411 usage && exit 1
1412 ;;
1413 k)
1414 REPOSITORY_KEY="${OPTARG}"
1415 REPO_ARGS+=(-k "$REPOSITORY_KEY")
1416 ;;
1417 u)
1418 REPOSITORY_BASE="${OPTARG}"
1419 REPO_ARGS+=(-u "$REPOSITORY_BASE")
1420 ;;
1421 R)
1422 RELEASE="${OPTARG}"
1423 REPO_ARGS+=(-R "$RELEASE")
1424 ;;
1425 D)
1426 OSM_DEVOPS="${OPTARG}"
1427 ;;
1428 o)
1429 INSTALL_ONLY="y"
1430 [ "${OPTARG}" == "vimemu" ] && INSTALL_VIMEMU="y" && continue
1431 [ "${OPTARG}" == "elk_stack" ] && INSTALL_ELK="y" && continue
1432 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
1433 ;;
1434 O)
1435 INSTALL_TO_OPENSTACK="y"
1436 if [ -n "${OPTARG}" ]; then
1437 OPENSTACK_OPENRC_FILE_OR_CLOUD="${OPTARG}"
1438 else
1439 echo -e "Invalid argument for -O : ' $OPTARG'\n" >&2
1440 usage && exit 1
1441 fi
1442 ;;
1443 N)
1444 OPENSTACK_PUBLIC_NET_NAME="${OPTARG}"
1445 ;;
1446 m)
1447 [ "${OPTARG}" == "LW-UI" ] && TO_REBUILD="$TO_REBUILD LW-UI" && continue
1448 [ "${OPTARG}" == "NBI" ] && TO_REBUILD="$TO_REBUILD NBI" && continue
1449 [ "${OPTARG}" == "LCM" ] && TO_REBUILD="$TO_REBUILD LCM" && continue
1450 [ "${OPTARG}" == "RO" ] && TO_REBUILD="$TO_REBUILD RO" && continue
1451 [ "${OPTARG}" == "MON" ] && TO_REBUILD="$TO_REBUILD MON" && continue
1452 [ "${OPTARG}" == "POL" ] && TO_REBUILD="$TO_REBUILD POL" && continue
1453 [ "${OPTARG}" == "KAFKA" ] && TO_REBUILD="$TO_REBUILD KAFKA" && continue
1454 [ "${OPTARG}" == "MONGO" ] && TO_REBUILD="$TO_REBUILD MONGO" && continue
1455 [ "${OPTARG}" == "PROMETHEUS" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS" && continue
1456 [ "${OPTARG}" == "PROMETHEUS-CADVISOR" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS-CADVISOR" && continue
1457 [ "${OPTARG}" == "KEYSTONE-DB" ] && TO_REBUILD="$TO_REBUILD KEYSTONE-DB" && continue
1458 [ "${OPTARG}" == "GRAFANA" ] && TO_REBUILD="$TO_REBUILD GRAFANA" && continue
1459 [ "${OPTARG}" == "NONE" ] && TO_REBUILD="$TO_REBUILD NONE" && continue
1460 [ "${OPTARG}" == "PLA" ] && TO_REBUILD="$TO_REBUILD PLA" && continue
1461 ;;
1462 H)
1463 OSM_VCA_HOST="${OPTARG}"
1464 ;;
1465 S)
1466 OSM_VCA_SECRET="${OPTARG}"
1467 ;;
1468 s)
1469 OSM_STACK_NAME="${OPTARG}" && [ -n "$KUBERNETES" ] && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
1470 ;;
1471 w)
1472 # when specifying workdir, do not use sudo for access
1473 WORKDIR_SUDO=
1474 OSM_WORK_DIR="${OPTARG}"
1475 ;;
1476 t)
1477 OSM_DOCKER_TAG="${OPTARG}"
1478 REPO_ARGS+=(-t "$OSM_DOCKER_TAG")
1479 ;;
1480 U)
1481 DOCKER_USER="${OPTARG}"
1482 ;;
1483 P)
1484 OSM_VCA_PUBKEY=$(cat ${OPTARG})
1485 ;;
1486 A)
1487 OSM_VCA_APIPROXY="${OPTARG}"
1488 ;;
1489 l)
1490 LXD_CLOUD_FILE="${OPTARG}"
1491 ;;
1492 L)
1493 LXD_CRED_FILE="${OPTARG}"
1494 ;;
1495 K)
1496 CONTROLLER_NAME="${OPTARG}"
1497 ;;
1498 -)
1499 [ "${OPTARG}" == "help" ] && usage && exit 0
1500 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && PULL_IMAGES="" && continue
1501 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
1502 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
1503 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
1504 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
1505 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
1506 [ "${OPTARG}" == "lxdinstall" ] && INSTALL_LXD="y" && continue
1507 [ "${OPTARG}" == "nolxd" ] && INSTALL_NOLXD="y" && continue
1508 [ "${OPTARG}" == "nodocker" ] && INSTALL_NODOCKER="y" && continue
1509 [ "${OPTARG}" == "lightweight" ] && INSTALL_LIGHTWEIGHT="y" && continue
1510 [ "${OPTARG}" == "vimemu" ] && INSTALL_VIMEMU="y" && continue
1511 [ "${OPTARG}" == "elk_stack" ] && INSTALL_ELK="y" && continue
1512 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
1513 [ "${OPTARG}" == "nohostports" ] && NO_HOST_PORTS="y" && continue
1514 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="y" && continue
1515 [ "${OPTARG}" == "nodockerbuild" ] && DOCKER_NOBUILD="y" && continue
1516 [ "${OPTARG}" == "nohostclient" ] && INSTALL_NOHOSTCLIENT="y" && continue
1517 [ "${OPTARG}" == "pullimages" ] && continue
1518 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
1519 [ "${OPTARG}" == "charmed" ] && CHARMED="y" && continue
1520 [ "${OPTARG}" == "bundle" ] && continue
1521 [ "${OPTARG}" == "k8s" ] && continue
1522 [ "${OPTARG}" == "lxd" ] && continue
1523 [ "${OPTARG}" == "lxd-cred" ] && continue
1524 [ "${OPTARG}" == "microstack" ] && continue
1525 [ "${OPTARG}" == "ha" ] && continue
1526 [ "${OPTARG}" == "tag" ] && continue
1527 [ "${OPTARG}" == "pla" ] && INSTALL_PLA="y" && continue
1528 [ "${OPTARG}" == "volume" ] && OPENSTACK_ATTACH_VOLUME="true" && continue
1529 echo -e "Invalid option: '--$OPTARG'\n" >&2
1530 usage && exit 1
1531 ;;
1532 :)
1533 echo "Option -$OPTARG requires an argument" >&2
1534 usage && exit 1
1535 ;;
1536 \?)
1537 echo -e "Invalid option: '-$OPTARG'\n" >&2
1538 usage && exit 1
1539 ;;
1540 h)
1541 usage && exit 0
1542 ;;
1543 y)
1544 ASSUME_YES="y"
1545 ;;
1546 *)
1547 usage && exit 1
1548 ;;
1549 esac
1550 done
1551
1552 [ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" != " NONE" ] && echo $TO_REBUILD | grep -q NONE && FATAL "Incompatible option: -m NONE cannot be used with other -m options"
1553 [ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" == " PLA" ] && [ -z "$INSTALL_PLA" ] && FATAL "Incompatible option: -m PLA cannot be used without --pla option"
1554
1555 if [ -n "$SHOWOPTS" ]; then
1556 dump_vars
1557 exit 0
1558 fi
1559
1560 if [ -n "$CHARMED" ]; then
1561 if [ -n "$UNINSTALL" ]; then
1562 /usr/share/osm-devops/installers/charmed_uninstall.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"
1563 else
1564 /usr/share/osm-devops/installers/charmed_install.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"
1565
1566 echo "Your installation is now complete, follow these steps for configuring the osmclient:"
1567 echo
1568 echo "1. Get the NBI IP with the following command:"
1569 echo
1570 echo NBI_IP='`juju status --format json | jq -rc '"'"'.applications."nbi-k8s".address'"'"'`'
1571 echo
1572 echo "2. Create the OSM_HOSTNAME environment variable with the NBI IP"
1573 echo
1574 echo "export OSM_HOSTNAME=\$NBI_IP"
1575 echo
1576 echo "3. Add the previous command to your .bashrc for other Shell sessions"
1577 echo
1578 echo "echo \"export OSM_HOSTNAME=\$NBI_IP\" >> ~/.bashrc"
1579 echo
1580 echo "DONE"
1581 fi
1582
1583 exit 0
1584 fi
1585
1586 # if develop, we force master
1587 [ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
1588
1589 need_packages="git wget curl tar"
1590
1591 [ -n "$INSTALL_TO_OPENSTACK" ] && install_to_openstack $OPENSTACK_OPENRC_FILE_OR_CLOUD $OPENSTACK_PUBLIC_NET_NAME $OPENSTACK_ATTACH_VOLUME && echo -e "\nDONE" && exit 0
1592
1593 echo -e "Checking required packages: $need_packages"
1594 dpkg -l $need_packages &>/dev/null \
1595 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
1596 || sudo apt-get update \
1597 || FATAL "failed to run apt-get update"
1598 dpkg -l $need_packages &>/dev/null \
1599 || ! echo -e "Installing $need_packages requires root privileges." \
1600 || sudo apt-get install -y $need_packages \
1601 || FATAL "failed to install $need_packages"
1602 sudo snap install jq
1603 if [ -z "$OSM_DEVOPS" ]; then
1604 if [ -n "$TEST_INSTALLER" ]; then
1605 echo -e "\nUsing local devops repo for OSM installation"
1606 OSM_DEVOPS="$(dirname $(realpath $(dirname $0)))"
1607 else
1608 echo -e "\nCreating temporary dir for OSM installation"
1609 OSM_DEVOPS="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
1610 trap 'rm -rf "$OSM_DEVOPS"' EXIT
1611
1612 git clone https://osm.etsi.org/gerrit/osm/devops.git $OSM_DEVOPS
1613
1614 if [ -z "$COMMIT_ID" ]; then
1615 echo -e "\nGuessing the current stable release"
1616 LATEST_STABLE_DEVOPS=`git -C $OSM_DEVOPS tag -l v[0-9].* | sort -V | tail -n1`
1617 [ -z "$LATEST_STABLE_DEVOPS" ] && echo "Could not find the current latest stable release" && exit 0
1618
1619 echo "Latest tag in devops repo: $LATEST_STABLE_DEVOPS"
1620 COMMIT_ID="tags/$LATEST_STABLE_DEVOPS"
1621 else
1622 echo -e "\nDEVOPS Using commit $COMMIT_ID"
1623 fi
1624 git -C $OSM_DEVOPS checkout $COMMIT_ID
1625 fi
1626 fi
1627
1628 . $OSM_DEVOPS/common/all_funcs
1629
1630 [ -n "$INSTALL_LIGHTWEIGHT" ] && [ -n "$UNINSTALL" ] && uninstall_lightweight && echo -e "\nDONE" && exit 0
1631 [ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_ELK" ] && deploy_elk
1632 #[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_PERFMON" ] && deploy_perfmon
1633 [ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_VIMEMU" ] && install_vimemu
1634 [ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_K8S_MONITOR" ] && install_k8s_monitoring
1635 [ -n "$INSTALL_ONLY" ] && echo -e "\nDONE" && exit 0
1636
1637 #Installation starts here
1638 wget -q -O- https://osm-download.etsi.org/ftp/osm-8.0-eight/README.txt &> /dev/null
1639 track start
1640
1641 [ -n "$INSTALL_LIGHTWEIGHT" ] && install_lightweight && echo -e "\nDONE" && exit 0
1642 echo -e "\nInstalling OSM from refspec: $COMMIT_ID"
1643 if [ -n "$INSTALL_FROM_SOURCE" ] && [ -z "$ASSUME_YES" ]; then
1644 ! ask_user "The installation will take about 75-90 minutes. Continue (Y/n)? " y && echo "Cancelled!" && exit 1
1645 fi
1646
1647 echo -e "Checking required packages: lxd"
1648 lxd --version &>/dev/null || FATAL "lxd not present, exiting."
1649 [ -n "$INSTALL_LXD" ] && echo -e "\nInstalling and configuring lxd" && install_lxd
1650
1651 # use local devops for containers
1652 export OSM_USE_LOCAL_DEVOPS=true
1653
1654 #Install osmclient
1655
1656 #Install vim-emu (optional)
1657 [ -n "$INSTALL_VIMEMU" ] && install_docker_ce && install_vimemu
1658
1659 wget -q -O- https://osm-download.etsi.org/ftp/osm-8.0-eight/README2.txt &> /dev/null
1660 track end
1661 echo -e "\nDONE"
1662
1663